Index: /stable/HeuristicLab 3.3 Hive.Slave.sln
===================================================================
--- /stable/HeuristicLab 3.3 Hive.Slave.sln	(revision 11748)
+++ /stable/HeuristicLab 3.3 Hive.Slave.sln	(revision 11749)
@@ -1,5 +1,5 @@
 ﻿
-Microsoft Visual Studio Solution File, Format Version 11.00
-# Visual Studio 2010
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 2012
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave-3.3", "HeuristicLab.Clients.Hive.Slave\3.3\HeuristicLab.Clients.Hive.Slave-3.3.csproj", "{989FE92B-484E-41EE-87E2-6A24AF0381D8}"
 EndProject
@@ -12,9 +12,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3", "HeuristicLab.Clients.Hive.Slave.TrayIcon\3.3\HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3.csproj", "{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}"
 EndProject
-Project("{54435603-DBB4-11D2-8724-00A0C9A8B90C}") = "HeuristicLab.Clients.Hive.Slave.TrayIconSetup-3.3", "HeuristicLab.Clients.Hive.Slave.TrayIconSetup\HeuristicLab.Clients.Hive.Slave.TrayIconSetup.vdproj", "{57E37188-4523-4F8D-8CEF-AE0AA27BB754}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.WindowsService-3.3", "HeuristicLab.Clients.Hive.Slave.WindowsService\3.3\HeuristicLab.Clients.Hive.Slave.WindowsService-3.3.csproj", "{BA8001DE-E83C-4B1F-8B2E-2695C4222491}"
-EndProject
-Project("{54435603-DBB4-11D2-8724-00A0C9A8B90C}") = "HeuristicLab.Clients.Hive.Slave.WindowsServiceSetup-3.3", "HeuristicLab.Clients.Hive.Slave.WindowsServiceSetup\HeuristicLab.Clients.Hive.Slave.WindowsServiceSetup.vdproj", "{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}"
 EndProject
 Global
@@ -88,16 +84,4 @@
 		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x86.ActiveCfg = Release|x86
 		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}.Release|x86.Build.0 = Release|x86
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|Any CPU.ActiveCfg = Debug
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|Any CPU.Build.0 = Debug
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|x64.ActiveCfg = Debug
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|x64.Build.0 = Debug
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|x86.ActiveCfg = Debug
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Debug|x86.Build.0 = Debug
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Release|Any CPU.ActiveCfg = Release
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Release|Any CPU.Build.0 = Release
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Release|x64.ActiveCfg = Release
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Release|x64.Build.0 = Release
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Release|x86.ActiveCfg = Release
-		{57E37188-4523-4F8D-8CEF-AE0AA27BB754}.Release|x86.Build.0 = Release
 		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -112,16 +96,4 @@
 		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x86.ActiveCfg = Release|x86
 		{BA8001DE-E83C-4B1F-8B2E-2695C4222491}.Release|x86.Build.0 = Release|x86
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|Any CPU.ActiveCfg = Debug
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|Any CPU.Build.0 = Debug
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|x64.ActiveCfg = Debug
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|x64.Build.0 = Debug
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|x86.ActiveCfg = Debug
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Debug|x86.Build.0 = Debug
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Release|Any CPU.ActiveCfg = Release
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Release|Any CPU.Build.0 = Release
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Release|x64.ActiveCfg = Release
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Release|x64.Build.0 = Release
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Release|x86.ActiveCfg = Release
-		{C16CA1A6-7AE8-4B87-A6A6-9C290E8B9646}.Release|x86.Build.0 = Release
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /stable/HeuristicLab 3.3 Services.sln
===================================================================
--- /stable/HeuristicLab 3.3 Services.sln	(revision 11748)
+++ /stable/HeuristicLab 3.3 Services.sln	(revision 11749)
@@ -1,5 +1,5 @@
 ﻿
-Microsoft Visual Studio Solution File, Format Version 11.00
-# Visual Studio 2010
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 2012
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{96396439-A764-4022-A8D2-BE021449B8D1}"
 	ProjectSection(SolutionItems) = preProject
@@ -24,5 +24,5 @@
 	ProjectSection(WebsiteProperties) = preProject
 		TargetFrameworkMoniker = ".NETFramework,Version%3Dv4.0"
-		ProjectReferences = "{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}|HeuristicLab.Services.Hive-3.3.dll;{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}|HeuristicLab.Services.Hive.DataAccess-3.3.dll;"
+		ProjectReferences = "{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE}|HeuristicLab.Services.Hive-3.3.dll;{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}|HeuristicLab.Services.Hive.DataAccess-3.3.dll;{9FAC0B23-2730-452A-9BA0-D7CA1746C541}|HeuristicLab.Services.Access.dll;{BE9B0229-9150-49A4-AEA6-BB58E055992F}|HeuristicLab.GeoIP.dll;{0F652437-998A-4EAB-8BF1-444B5FE8CE97}|HeuristicLab.Services.Access.DataAccess.dll;"
 		Debug.AspNetCompiler.VirtualPath = "/Hive-3.3"
 		Debug.AspNetCompiler.PhysicalPath = "HeuristicLab.Services.Hive.Web\Hive-3.3\"
@@ -45,6 +45,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Hive.JanitorService-3.3", "HeuristicLab.Services.Hive.JanitorService\3.3\HeuristicLab.Services.Hive.JanitorService-3.3.csproj", "{F685556B-F6EB-4143-8E7E-662D00FDD299}"
-EndProject
-Project("{54435603-DBB4-11D2-8724-00A0C9A8B90C}") = "HeuristicLab.Services.Hive.JanitorServiceSetup-3.3", "HeuristicLab.Services.Hive.JanitorServiceSetup\HeuristicLab.Services.Hive.JanitorServiceSetup-3.3.vdproj", "{034C2EE4-E303-4E45-98AB-F0074EC83B81}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.GeoIP", "HeuristicLab.GeoIP\1.12\HeuristicLab.GeoIP.csproj", "{BE9B0229-9150-49A4-AEA6-BB58E055992F}"
@@ -150,16 +148,4 @@
 		{F685556B-F6EB-4143-8E7E-662D00FDD299}.Release|x86.ActiveCfg = Release|x86
 		{F685556B-F6EB-4143-8E7E-662D00FDD299}.Release|x86.Build.0 = Release|x86
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|Any CPU.ActiveCfg = Debug
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|Any CPU.Build.0 = Debug
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|x64.ActiveCfg = Debug
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|x64.Build.0 = Debug
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|x86.ActiveCfg = Debug
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Debug|x86.Build.0 = Debug
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Release|Any CPU.ActiveCfg = Release
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Release|Any CPU.Build.0 = Release
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Release|x64.ActiveCfg = Release
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Release|x64.Build.0 = Release
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Release|x86.ActiveCfg = Release
-		{034C2EE4-E303-4E45-98AB-F0074EC83B81}.Release|x86.Build.0 = Release
 		{BE9B0229-9150-49A4-AEA6-BB58E055992F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{BE9B0229-9150-49A4-AEA6-BB58E055992F}.Debug|Any CPU.Build.0 = Debug|Any CPU
Index: /stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/Program.cs
===================================================================
--- /stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/Program.cs	(revision 11748)
+++ /stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/Program.cs	(revision 11749)
@@ -20,18 +20,36 @@
 #endregion
 
+using System;
+using System.Configuration.Install;
+using System.Reflection;
 using System.ServiceProcess;
 
 namespace HeuristicLab.Clients.Hive.SlaveCore.WindowsService {
   static class Program {
-    /// <summary>
-    /// The main entry point for the application.
-    /// </summary>
-    static void Main() {
-      ServiceBase[] ServicesToRun;
-      ServicesToRun = new ServiceBase[]  
-			{ 
-				new SlaveWindowsService() 
-			};
-      ServiceBase.Run(ServicesToRun);
+    private static void Main(string[] args) {
+      // Install as service, see http://stackoverflow.com/a/12703878
+      if (Environment.UserInteractive) {
+        try {
+          string parameter = string.Concat(args);
+          switch (parameter) {
+            case "--install":
+              ManagedInstallerClass.InstallHelper(new[] { Assembly.GetExecutingAssembly().Location });
+              break;
+            case "--uninstall":
+              ManagedInstallerClass.InstallHelper(new[] { "/u", Assembly.GetExecutingAssembly().Location });
+              break;
+          }
+        }
+        catch (Exception ex) {
+          Console.WriteLine("Error on (un)install of Hive Slave service: " + Environment.NewLine + ex);
+        }
+      } else {
+        ServiceBase[] ServicesToRun;
+        ServicesToRun = new ServiceBase[]
+        {
+          new SlaveWindowsService()
+        };
+        ServiceBase.Run(ServicesToRun);
+      }
     }
   }
Index: /stable/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj
===================================================================
--- /stable/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 11748)
+++ /stable/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 11749)
@@ -135,7 +135,12 @@
     </EmbeddedResource>
   </ItemGroup>
+  <ItemGroup>
+    <Content Include="ICSharpCode.SharpZipLib License.txt">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -143,5 +148,5 @@
 
 call PreBuildEvent.cmd</PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: /stable/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt
===================================================================
--- /stable/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt	(revision 11749)
+++ /stable/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt	(revision 11749)
@@ -0,0 +1,13 @@
+#ziplib (SharpZipLib, formerly NZipLib) is a Zip, GZip, Tar and BZip2 library written entirely in C# for the .NET platform. It is implemented as an assembly (installable in the GAC), and thus can easily be incorporated into other projects (in any .NET language). The creator of #ziplib put it this way: "I've ported the zip library over to C# because I needed gzip/zip compression and I didn't want to use libzip.dll or something like this. I want all in pure C#."
+
+License
+
+The library is released under the GPL with the following exception:
+
+Linking this library statically or dynamically with other modules is making a combined work based on this library. Thus, the terms and conditions of the GNU General Public License cover the whole combination.
+
+As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.
+
+Note: The exception is changed to reflect the latest GNU Classpath exception. Older versions of #ziplib did have another exception, but the new one is clearer and it doesn't break compatibility with the old one.
+
+Bottom line: In plain English this means you can use this library in commercial closed-source applications.
Index: /stable/HeuristicLab.Services.Hive.JanitorService/3.3/Program.cs
===================================================================
--- /stable/HeuristicLab.Services.Hive.JanitorService/3.3/Program.cs	(revision 11748)
+++ /stable/HeuristicLab.Services.Hive.JanitorService/3.3/Program.cs	(revision 11749)
@@ -20,18 +20,36 @@
 #endregion
 
+using System;
+using System.Configuration.Install;
+using System.Reflection;
 using System.ServiceProcess;
 
 namespace HeuristicLab.Services.Hive.JanitorService {
   static class Program {
-    /// <summary>
-    /// The main entry point for the application.
-    /// </summary>
-    static void Main() {
-      ServiceBase[] ServicesToRun;
-      ServicesToRun = new ServiceBase[] 
-			{ 
-				new JanitorService() 
-			};
-      ServiceBase.Run(ServicesToRun);
+    private static void Main(string[] args) {
+      // Install as service, see http://stackoverflow.com/a/12703878
+      if (Environment.UserInteractive) {
+        try {
+          string parameter = string.Concat(args);
+          switch (parameter) {
+            case "--install":
+              ManagedInstallerClass.InstallHelper(new[] { Assembly.GetExecutingAssembly().Location });
+              break;
+            case "--uninstall":
+              ManagedInstallerClass.InstallHelper(new[] { "/u", Assembly.GetExecutingAssembly().Location });
+              break;
+          }
+        }
+        catch (Exception ex) {
+          Console.WriteLine("Error on (un)install of Hive Slave service: " + Environment.NewLine + ex);
+        }
+      } else {
+        ServiceBase[] ServicesToRun;
+        ServicesToRun = new ServiceBase[]
+        {
+          new JanitorService()
+        };
+        ServiceBase.Run(ServicesToRun);
+      }
     }
   }
Index: /stable/Installers/HiveJanitorServiceInstaller.nsi
===================================================================
--- /stable/Installers/HiveJanitorServiceInstaller.nsi	(revision 11749)
+++ /stable/Installers/HiveJanitorServiceInstaller.nsi	(revision 11749)
@@ -0,0 +1,92 @@
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+ 
+; NSIS installer script for HeuristicLab Hive Janitor Service
+; NSIS version: 3.0b0
+
+Name "HeuristicLab Hive Janitor Service"
+OutFile "HeuristicLab Hive Janitor Service Installer.exe"
+
+; Build configuration is either Debug or Release
+!define BUILDCONFIGURATION "Debug"
+!define JANITORBUILDPATH "..\HeuristicLab.Services.Hive.JanitorService\3.3\bin\${BUILDCONFIGURATION}"
+!define VERSION "3.3.10"
+
+InstallDir $PROGRAMFILES\HeuristicLabHiveJanitorService
+RequestExecutionLevel admin
+
+Page license
+Page directory
+Page instfiles
+
+UninstPage uninstConfirm
+UninstPage instfiles
+
+LicenseData "..\HeuristicLab\3.3\GNU General Public License.txt"
+Icon "..\HeuristicLab\3.3\HeuristicLab.ico"
+
+
+Section "HeuristicLabHiveJanitorService (required)"
+	SetOutPath $INSTDIR
+
+	File "${JANITORBUILDPATH}\GeoIP.dat"
+	File "${JANITORBUILDPATH}\HeuristicLab.Common-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Persistence-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.PluginInfrastructure-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Access.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive.DataAccess-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive.JanitorService-3.3.exe"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive.JanitorService-3.3.exe.config"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Tracing-3.3.dll"
+	
+	WriteRegStr HKLM SOFTWARE\HeuristicLabHiveJanitorService "Install_Dir" "$INSTDIR"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "DisplayName" "HeuristicLabHiveJanitorService"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "UninstallString" '"$INSTDIR\uninstall.exe"'
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "NoModify" 1
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "NoRepair" 1
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "DisplayVersion" "${VERSION}"
+	WriteUninstaller "uninstall.exe"
+
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe" --install'
+SectionEnd
+
+
+Section "un.Uninstall"  
+	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService"
+	DeleteRegKey HKLM SOFTWARE\HeuristicLabHiveJanitorService
+	  
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe" --uninstall'
+	  
+	Delete "$INSTDIR\GeoIP.dat"
+	Delete "$INSTDIR\HeuristicLab.Common-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Persistence-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.PluginInfrastructure-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Services.Access.dll"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive.DataAccess-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe.config"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Tracing-3.3.dll"
+	Delete "$INSTDIR\uninstall.exe"
+
+	RMDir "$INSTDIR"
+SectionEnd
+
+
Index: /stable/Installers/HiveSlaveInstaller.nsi
===================================================================
--- /stable/Installers/HiveSlaveInstaller.nsi	(revision 11749)
+++ /stable/Installers/HiveSlaveInstaller.nsi	(revision 11749)
@@ -0,0 +1,107 @@
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+ 
+; NSIS installer script for HeuristicLab Hive Slave
+; NSIS version: 3.0b0
+
+Name "HeuristicLab Hive Slave"
+OutFile "HeuristicLab Hive Slave Installer.exe"
+
+; Build configuration is either Debug or Release
+!define BUILDCONFIGURATION "Debug"
+!define SLAVEBUILDPATH "..\HeuristicLab.Clients.Hive.Slave.WindowsService\3.3\bin\${BUILDCONFIGURATION}"
+!define VERSION "3.3.10"
+
+InstallDir $PROGRAMFILES\HeuristicLabHiveSlave
+RequestExecutionLevel admin
+
+Page license
+Page directory
+Page instfiles
+
+UninstPage uninstConfirm
+UninstPage instfiles
+
+LicenseData "..\HeuristicLab\3.3\GNU General Public License.txt"
+Icon "..\HeuristicLab\3.3\HeuristicLab.ico"
+
+
+Section "HeuristicLabHiveSlave (required)"
+	SetOutPath $INSTDIR
+
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Common-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Collections-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Common.Resources-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Common-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Core-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Data-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Hive-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.MainForm-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Optimization-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Parameters-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Persistence-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.PluginInfrastructure-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Tracing-3.3.dll"
+
+
+	WriteRegStr HKLM SOFTWARE\HeuristicLabHiveSlave "Install_Dir" "$INSTDIR"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "DisplayName" "HeuristicLabHiveSlave"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "UninstallString" '"$INSTDIR\uninstall.exe"'
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "NoModify" 1
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "NoRepair" 1
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "DisplayVersion" "${VERSION}"
+	WriteUninstaller "uninstall.exe"
+
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe" --install'
+SectionEnd
+
+
+Section "un.Uninstall"  
+	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave"
+	DeleteRegKey HKLM SOFTWARE\HeuristicLabHiveSlave
+
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe" --uninstall'
+	  
+	Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe
+	Delete $INSTDIR\HeuristicLab.Clients.Common-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config
+	Delete $INSTDIR\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Clients.Hive-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Collections-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Common.Resources-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Common-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Core-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Data-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Hive-3.3.dll
+	Delete $INSTDIR\HeuristicLab.MainForm-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Optimization-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Parameters-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Persistence-3.3.dll
+	Delete $INSTDIR\HeuristicLab.PluginInfrastructure-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Tracing-3.3.dll
+	Delete $INSTDIR\uninstall.exe
+
+	RMDir "$INSTDIR"
+SectionEnd
+
+